die () {
    echo "$@" 1>&2
    exit 1
}

test_as () {
    echo "$2" | ../assembler/instr16-as -o tmp.o \
    && od -An -tx1 tmp.o | sed -e 's/^ //' > tmp.hex \
    && echo "$1" | diff -u - tmp.hex \
    || die "Incorrect assembly for: $2"
}

test_getd () {    
    if [ "$1" = "-b" ] ; then
	getd_base=$2
	shift 2;
    else
	getd_base=''
    fi
    echo "$1" | ../simulator/instr16 ../examples/getd-test $getd_base > tmp.out \
	&& echo $2 | diff -u - tmp.out \
	|| die "Failed for input $1 base: ${getd_base:-default}"   
}
